diff --git a/web/pgadmin/browser/register_browser_preferences.py b/web/pgadmin/browser/register_browser_preferences.py
index af7dc4f2..0b0224b3 100644
--- a/web/pgadmin/browser/register_browser_preferences.py
+++ b/web/pgadmin/browser/register_browser_preferences.py
@@ -519,7 +519,7 @@ def register_browser_preferences(self):
 
     self.open_in_new_tab = self.preference.register(
         'tab_settings', 'new_browser_tab_open',
-        gettext("Open in new browser tab"), 'select2', None,
+        gettext("Open in new browser tab"), 'select', None,
         category_label=PREF_LABEL_OPTIONS,
         options=ope_new_tab_options,
         help_str=gettext(
@@ -527,7 +527,7 @@ def register_browser_preferences(self):
             'or PSQL Tool from the drop-down to set '
             'open in new browser tab for that particular module.'
         ),
-        select2={
+        control_props={
             'multiple': True, 'allowClear': False,
             'tags': True, 'first_empty': False,
             'selectOnClose': False, 'emptyOptions': True,
diff --git a/web/pgadmin/browser/server_groups/servers/static/js/binary_path.ui.js b/web/pgadmin/browser/server_groups/servers/static/js/binary_path.ui.js
new file mode 100644
index 00000000..af31cedb
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/static/js/binary_path.ui.js
@@ -0,0 +1,68 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import gettext from 'sources/gettext';
+import _ from 'lodash';
+import url_for from 'sources/url_for';
+import BaseUISchema from 'sources/SchemaView/base_schema.ui';
+import getApiInstance from '../../../../../static/js/api_instance';
+import Notify from '../../../../../static/js/helpers/Notifier';
+
+export function getBinaryPathSchema() {
+
+  return new BinaryPathSchema();
+}
+
+export default class BinaryPathSchema extends BaseUISchema {
+  constructor() {
+    super({
+      isDefault: false,
+      serverType: undefined,
+      binaryPath: null,
+    });
+  }
+
+  get baseFields() {
+    return [
+      {
+        id: 'isDefault', label: gettext('Set as default'), type: 'switch',
+        cell: 'switch', width: 32,
+        disabled: (state) => {
+          return state.binaryPath ? false : true;
+        }
+      },
+      {
+        id: 'serverType',
+        label: gettext('Database Server'),
+        type: 'text', cell: '',
+        width: 40,
+      },
+      {
+        id: 'binaryPath', label: gettext('Binary Path'), cell: 'file',
+        isvalidate: true, controlProps: { dialogType: 'select_folder', supportedTypes: ['*', 'sql', 'backup'], dialogTitle: 'Select folder' },
+        validate: (data) => {
+          const api = getApiInstance();
+          if (_.isNull(data) || data.trim() === '') {
+            Notify.alert(gettext('Validate Path'), gettext('Path should not be empty.'));
+          }
+
+          api.post(url_for('misc.validate_binary_path'),
+            JSON.stringify({ 'utility_path': data }))
+            .then(function (res) {
+              Notify.alert(gettext('Validate binary path'), gettext(res.data.data));
+            })
+            .catch(function (error) {
+              Notify.pgNotifier(error, gettext('Failed to validate binary path.'));
+            });
+          return true;
+        }
+      },
+    ];
+  }
+}
diff --git a/web/pgadmin/misc/__init__.py b/web/pgadmin/misc/__init__.py
index fb436d70..6cd83404 100644
--- a/web/pgadmin/misc/__init__.py
+++ b/web/pgadmin/misc/__init__.py
@@ -67,7 +67,10 @@ class MiscModule(PgAdminModule):
             'user_language', 'user_language',
             gettext("User language"), 'options', 'en',
             category_label=gettext('User language'),
-            options=lang_options
+            options=lang_options,
+            control_props={
+                'allowClear': False,
+            }
         )
 
         theme_options = []
@@ -90,6 +93,9 @@ class MiscModule(PgAdminModule):
             gettext("Theme"), 'options', 'standard',
             category_label=gettext('Themes'),
             options=theme_options,
+            control_props={
+                'allowClear': False,
+            },
             help_str=gettext(
                 'A refresh is required to apply the theme. Below is the '
                 'preview of the theme'
diff --git a/web/pgadmin/misc/file_manager/__init__.py b/web/pgadmin/misc/file_manager/__init__.py
index d132e46e..ca69e609 100644
--- a/web/pgadmin/misc/file_manager/__init__.py
+++ b/web/pgadmin/misc/file_manager/__init__.py
@@ -167,10 +167,14 @@ class FileManagerModule(PgAdminModule):
         )
         self.file_dialog_view = self.preference.register(
             'options', 'file_dialog_view',
-            gettext("File dialog view"), 'options', 'list',
+            gettext("File dialog view"), 'select', 'list',
             category_label=PREF_LABEL_OPTIONS,
             options=[{'label': gettext('List'), 'value': 'list'},
-                     {'label': gettext('Grid'), 'value': 'grid'}]
+                     {'label': gettext('Grid'), 'value': 'grid'}],
+            control_props={
+                'allowClear': False,
+                'tags': False
+            },
         )
         self.show_hidden_files = self.preference.register(
             'options', 'show_hidden_files',
@@ -236,7 +240,7 @@ def file_manager_config(trans_id):
     """render the required json"""
     data = Filemanager.get_trasaction_selection(trans_id)
     pref = Preferences.module('file_manager')
-    file_dialog_view = pref.preference('file_dialog_view').get()
+    file_dialog_view = pref.preference('file_dialog_view').get()[0]
     show_hidden_files = pref.preference('show_hidden_files').get()
 
     return Response(response=render_template(
diff --git a/web/pgadmin/preferences/__init__.py b/web/pgadmin/preferences/__init__.py
index 9872a672..3f754ada 100644
--- a/web/pgadmin/preferences/__init__.py
+++ b/web/pgadmin/preferences/__init__.py
@@ -37,26 +37,23 @@ class PreferencesModule(PgAdminModule):
     """
 
     def get_own_javascripts(self):
-        return [{
-            'name': 'pgadmin.preferences',
-            'path': url_for('preferences.index') + 'preferences',
-            'when': None
-        }]
+        scripts = list()
+        for name, script in [
+            ['pgadmin.preferences', 'js/preferences']
+        ]:
+            scripts.append({
+                'name': name,
+                'path': url_for('preferences.index') + script,
+                'when': None
+            })
+
+        return scripts
 
     def get_own_stylesheets(self):
         return []
 
     def get_own_menuitems(self):
-        return {
-            'file_items': [
-                MenuItem(name='mnu_preferences',
-                         priority=997,
-                         module="pgAdmin.Preferences",
-                         callback='show',
-                         icon='fa fa-cog',
-                         label=gettext('Preferences'))
-            ]
-        }
+        return {}
 
     def get_exposed_url_endpoints(self):
         """
@@ -149,7 +146,8 @@ def _iterate_categories(pref_d, label, res):
         "label": gettext(pref_d['label']),
         "inode": True,
         "open": True,
-        "branch": []
+        "children": [],
+        "value": gettext(pref_d['label']),
     }
 
     for c in pref_d['categories']:
@@ -162,13 +160,15 @@ def _iterate_categories(pref_d, label, res):
             "id": c['id'],
             "mid": pref_d['id'],
             "label": gettext(c['label']),
+            "value": '{0}{1}'.format(c['id'], gettext(c['label'])),
             "inode": False,
             "open": False,
-            "preferences": sorted(c['preferences'], key=label)
+            "preferences": sorted(c['preferences'], key=label),
+            "showCheckbox": False
         }
 
-        (om['branch']).append(oc)
-    om['branch'] = sorted(om['branch'], key=label)
+        (om['children']).append(oc)
+    om['children'] = sorted(om['children'], key=label)
 
     res.append(om)
 
@@ -194,53 +194,85 @@ def preferences_s():
     )
 
 
-@blueprint.route("/<int:pid>", methods=["PUT"], endpoint="update")
+def get_data():
+    pref_data = request.form if request.form else json.loads(
+        request.data.decode())
+
+    if not pref_data:
+        raise ValueError("Please provide the valid preferences data to save.")
+
+    return pref_data
+
+
+@blueprint.route("/", methods=["PUT"], endpoint="update")
 @login_required
-def save(pid):
+def save():
     """
     Save a specific preference.
     """
-    data = request.form if request.form else json.loads(request.data.decode())
+    pref_data = get_data()
 
-    if data['name'] in ['vw_edt_tab_title_placeholder',
-                        'qt_tab_title_placeholder',
-                        'debugger_tab_title_placeholder'] \
-            and data['value'].isspace():
-        data['value'] = ''
+    for data in pref_data:
+        if data['name'] in ['vw_edt_tab_title_placeholder',
+                            'qt_tab_title_placeholder',
+                            'debugger_tab_title_placeholder'] \
+                and data['value'].isspace():
+            data['value'] = ''
 
-    res, msg = Preferences.save(
-        data['mid'], data['category_id'], data['id'], data['value'])
-    sgm.get_nodes(sgm)
+        if data['name'] == 'pg_bin_dir':
+            check_binary_path_data(data)
 
-    if not res:
-        return internal_server_error(errormsg=msg)
+        res, msg = Preferences.save(
+            data['mid'], data['category_id'], data['id'], data['value'])
+        sgm.get_nodes(sgm)
 
-    response = success_return()
+        if not res:
+            return internal_server_error(errormsg=msg)
 
-    # Set cookie & session for language settings.
-    # This will execute every time as could not find the better way to know
-    # that which preference is getting updated.
+        response = success_return()
 
-    misc_preference = Preferences.module('misc')
-    user_languages = misc_preference.preference(
-        'user_language'
-    )
+        # Set cookie & session for language settings.
+        # This will execute every time as could not find the better way to know
+        # that which preference is getting updated.
+
+        misc_preference = Preferences.module('misc')
+        user_languages = misc_preference.preference(
+            'user_language'
+        )
 
-    language = 'en'
-    if user_languages:
-        language = user_languages.get() or language
+        language = 'en'
+        if user_languages:
+            language = user_languages.get() or language
 
-    domain = dict()
-    if config.COOKIE_DEFAULT_DOMAIN and\
-            config.COOKIE_DEFAULT_DOMAIN != 'localhost':
-        domain['domain'] = config.COOKIE_DEFAULT_DOMAIN
+        domain = dict()
+        if config.COOKIE_DEFAULT_DOMAIN and \
+                config.COOKIE_DEFAULT_DOMAIN != 'localhost':
+            domain['domain'] = config.COOKIE_DEFAULT_DOMAIN
 
-    setattr(session, 'PGADMIN_LANGUAGE', language)
-    response.set_cookie("PGADMIN_LANGUAGE", value=language,
-                        path=config.COOKIE_DEFAULT_PATH,
-                        secure=config.SESSION_COOKIE_SECURE,
-                        httponly=config.SESSION_COOKIE_HTTPONLY,
-                        samesite=config.SESSION_COOKIE_SAMESITE,
-                        **domain)
+        setattr(session, 'PGADMIN_LANGUAGE', language)
+        response.set_cookie("PGADMIN_LANGUAGE", value=language,
+                            path=config.COOKIE_DEFAULT_PATH,
+                            secure=config.SESSION_COOKIE_SECURE,
+                            httponly=config.SESSION_COOKIE_HTTPONLY,
+                            samesite=config.SESSION_COOKIE_SAMESITE,
+                            **domain)
 
     return response
+
+
+def check_binary_path_data(data):
+    pref_val = json.loads(data['value'])
+    pref_data = Preferences.preferences()
+    _data = [el for el in pref_data if el['id'] == data['mid']]
+    if _data:
+        categories = _data[0]['categories']
+        pref = [pref for ct in categories for pref in ct['preferences']
+                if
+                ct['id'] == data['category_id'] and pref['id'] == data[
+                    'id']]
+        if pref:
+            values = json.loads(pref[0]['value'])
+            pref = [pval if pval['version'] == val['version'] else val
+                    for val in values for pval in pref_val]
+            data['value'] = json.dumps(pref)
+    return data
diff --git a/web/pgadmin/preferences/static/js/components/PreferencesComponent.jsx b/web/pgadmin/preferences/static/js/components/PreferencesComponent.jsx
new file mode 100644
index 00000000..a433a835
--- /dev/null
+++ b/web/pgadmin/preferences/static/js/components/PreferencesComponent.jsx
@@ -0,0 +1,511 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import gettext from 'sources/gettext';
+import url_for from 'sources/url_for';
+import React, { useEffect } from 'react';
+import { Box } from '@material-ui/core';
+import PropTypes from 'prop-types';
+import { makeStyles } from '@material-ui/core/styles';
+import SchemaView from '../../../../static/js/SchemaView';
+import getApiInstance from '../../../../static/js/api_instance';
+import CloseSharpIcon from '@material-ui/icons/CloseSharp';
+import SaveSharpIcon from '@material-ui/icons/SaveSharp';
+import clsx from 'clsx';
+import Notify from '../../../../static/js/helpers/Notifier';
+import pgAdmin from 'sources/pgadmin';
+import { DefaultButton, PrimaryButton } from '../../../../static/js/components/Buttons';
+import BaseUISchema from 'sources/SchemaView/base_schema.ui';
+import { getBinaryPathSchema } from '../../../../browser/server_groups/servers/static/js/binary_path.ui';
+import PreferencesTree from './PreferencesTree';
+import { _set_dynamic_tab} from '../../../../tools/datagrid/static/js/show_query_tool';
+
+class PreferencesSchema extends BaseUISchema {
+  constructor(initValues = {}, schemaFields = []) {
+    super({
+      ...initValues
+    });
+    this.schemaFields = schemaFields;
+    this.category = '';
+  }
+
+  get idAttribute() {
+    return 'id';
+  }
+
+  setSelectedCategory(category) {
+    this.category = category;
+  }
+
+  get baseFields() {
+    return this.schemaFields;
+  }
+}
+
+const useStyles = makeStyles((theme) =>
+  ({
+    root: {
+      display: 'flex',
+      flexDirection: 'column',
+      flexGrow: 1,
+      height: '100%',
+      backgroundColor: theme.palette.background.default,
+      minHeight: 520,
+      minWidth: 700,
+      overflow: 'hidden',
+      '&$disabled': {
+        color: '#ddd',
+      }
+    },
+    body: {
+      display: 'flex',
+      flexDirection: 'column',
+      height: '100%',
+    },
+    preferences: {
+      borderColor: theme.otherVars.borderColor,
+      display: 'flex',
+      flexGrow: 1,
+      height: '100%',
+      minHeight: 0,
+      overflow: 'hidden'
+
+    },
+    treeContainer: {
+      flexBasis: '25%',
+      alignItems: 'flex-start',
+      paddingLeft: '5px',
+      minHeight: 0,
+    },
+    preferencesContainer: {
+      flexBasis: '75%',
+      padding: '5px',
+      borderColor: theme.otherVars.borderColor + '!important',
+      borderLeft: '1px solid',
+      position: 'relative',
+      height: '100%',
+      paddingTop: '5px',
+      overflow: 'auto'
+    },
+    actionBtn: {
+      alignItems: 'flex-start',
+    },
+    buttonMargin: {
+      marginLeft: '0.5em'
+    },
+    footer: {
+      borderTop: '1px solid #dde0e6 !important',
+      padding: '0.5rem',
+      display: 'flex',
+      width: '100%',
+      background: theme.otherVars.headerBg,
+      zIndex: 999,
+    },
+    customTreeClass: {
+      '& .react-checkbox-tree': {
+        height: '100% !important',
+        border: 'none !important',
+      },
+    },
+    preferencesTree: {
+      height: 'calc(100% - 50px)',
+      minHeight: 0
+    }
+  }),
+);
+
+
+function RightPanel({ schema, ...props }) {
+  let initData = () => new Promise((resolve, reject) => {
+    try {
+      resolve(props.initValues);
+    } catch (error) {
+      reject(error);
+    }
+  });
+
+  return (
+    <SchemaView
+      formType={'dialog'}
+      getInitData={initData}
+      viewHelperProps={{ mode: 'edit' }}
+      schema={schema}
+      showFooter={false}
+      isTabView={false}
+      onDataChange={(isChanged, changedData) => {
+        props.onDataChange(changedData);
+      }}
+    />
+  );
+}
+
+RightPanel.propTypes = {
+  schema: PropTypes.object,
+  initValues: PropTypes.object,
+  onDataChange: PropTypes.func
+};
+
+
+export default function PreferencesComponent({ ...props }) {
+  const classes = useStyles();
+  const [disableSave, setDisableSave] = React.useState(true);
+  const prefSchema = React.useRef(new PreferencesSchema({}, []));
+  const prefChangedData = React.useRef({});
+  const [prefTreeData, setPrefTreeData] = React.useState(null);
+  const [initValues, setInitValues] = React.useState({});
+  const [loadTree, setLoadTree] = React.useState(0);
+  const api = getApiInstance();
+
+  useEffect(() => {
+    const pref_url = url_for('preferences.index');
+    api({
+      url: pref_url,
+      method: 'GET',
+    }).then((res) => {
+      let preferencesData = [];
+      let preferencesTreeData = [];
+      let preferencesValues = {};
+      res.data.forEach(node => {
+        let id = Math.floor(Math.random() * 1000);
+        let tdata = {
+          'id': id.toString(),
+          'label': node.label,
+          '_label': node.label,
+          'name': node.label,
+          'icon': '',
+          'inode': true,
+          'type': 2,
+          '_type': node.label.toLowerCase(),
+          '_id': id,
+          '_pid': null,
+          'childrenNodes': [],
+          'expanded': true,
+        };
+
+        node.children.forEach(subNode => {
+          let sid = Math.floor(Math.random() * 1000);
+          let nodeData = {
+            'id': sid.toString(),
+            'label': subNode.label,
+            '_label': subNode.label,
+            'name': subNode.label,
+            'icon': '',
+            'inode': false,
+            '_type': subNode.label.toLowerCase(),
+            '_id': sid,
+            '_pid': node.id,
+            'type': 1,
+            'expanded': false,
+          };
+          subNode.preferences.forEach((element) => {
+            let addNote = false;
+            let note = '';
+            let type = getControlMappedForType(element.type);
+
+            if (type === 'file') {
+              addNote = true;
+              note = gettext('Enter the directory in which the psql, pg_dump, pg_dumpall, and pg_restore utilities can be found for the corresponding database server version.  The default path will be used for server versions that do not have a  path specified.');
+              element.type = 'collection';
+              element.schema = getBinaryPathSchema();
+              element.canAdd = false;
+              element.canDelete = false;
+              element.canEdit = false;
+              element.editable = false;
+              preferencesValues[element.id] = JSON.parse(element.value);
+            }
+            else if (type == 'select') {
+              if (element.control_props !== undefined) {
+                element.controlProps = element.control_props;
+              } else {
+                element.controlProps = {};
+              }
+              preferencesValues[element.id] = element.value;
+              element.type = type;
+            }
+            else if (type === 'keyboardShortcut') {
+              element.type = 'keyboardShortcut';
+              element.canAdd = false;
+              element.canDelete = false;
+              element.canEdit = false;
+              element.editable = false;
+              if (pgAdmin.Browser.get_preference(node.label.toLowerCase(), element.name)?.value) {
+                let temp = pgAdmin.Browser.get_preference(node.label.toLowerCase(), element.name).value;
+                preferencesValues[element.id] = temp;
+              } else {
+                preferencesValues[element.id] = element.value;
+              }
+              delete element.value;
+            } else if(type === 'threshold') {
+              element.type = 'threshold';
+
+              let _val = element.value.split('|');
+              preferencesValues[element.id] = {'warning': _val[0], 'alert': _val[1]};
+            } else {
+              element.type = type;
+              preferencesValues[element.id] = element.value;
+            }
+
+            delete element.value;
+            element.visible = false;
+            element.helpMessage = element?.help_str ? element.help_str : null;
+            preferencesData.push(element);
+
+            if (addNote) {
+              preferencesData.push(
+                {
+                  id: 'note_' + element.id,
+                  type: 'note', text: [
+                    '<ul><li>',
+                    gettext(note),
+                    '</li></ul>',
+                  ].join(''),
+                  visible: false,
+                  'parentId': nodeData['id']
+                },
+              );
+            }
+            element.parentId = nodeData['id'];
+          });
+          tdata['childrenNodes'].push(nodeData);
+        });
+
+        // set Preferences Tree data
+        preferencesTreeData.push(tdata);
+
+      });
+      setPrefTreeData(preferencesTreeData);
+      setInitValues(preferencesValues);
+      // set Preferences schema
+      prefSchema.current = new PreferencesSchema(preferencesValues, preferencesData);
+    }).catch((err) => {
+      Notify.alert(err.response.data);
+    });
+  }, []);
+
+  function getControlMappedForType(type) {
+    switch (type) {
+    case 'text':
+      return 'text';
+    case 'input':
+      return 'text';
+    case 'boolean':
+      return 'switch';
+    case 'node':
+      return 'switch';
+    case 'integer':
+      return 'numeric';
+    case 'numeric':
+      return 'numeric';
+    case 'date':
+      return 'datetimepicker';
+    case 'datetime':
+      return 'datetimepicker';
+    case 'options':
+      return 'select';
+    case 'select':
+      return 'select';
+    case 'select2':
+      return 'select';
+    case 'multiline':
+      return 'multiline';
+    case 'switch':
+      return 'switch';
+    case 'keyboardshortcut':
+      return 'keyboardShortcut';
+    case 'radioModern':
+      return 'toggle';
+    case 'selectFile':
+      return 'file';
+    case 'threshold':
+      return 'threshold';
+    default:
+      if (console && console.warn) {
+        // Warning for developer only.
+        console.warn(
+          'Hmm.. We don\'t know how to render this type - \'\'' + type + '\' of control.'
+        );
+      }
+      return 'input';
+    }
+  }
+
+  function getCollectionValue(_metadata, value) {
+    let val = value;
+    if (typeof (value) == 'object') {
+      if(_metadata[0].type == 'collection' && _metadata[0].schema) {
+        if('binaryPath' in value.changed[0]) {
+          val = JSON.stringify(value.changed);
+        }else {
+          let key_val = {
+            'char': value.changed[0]['key'],
+            'key_code': value.changed[0]['code'],
+          };
+          value.changed[0]['key'] = key_val;
+          val = value.changed[0];
+        }
+      } else if('warning' in value) {
+        val = value['warning'] + '|' + value['alert'];
+      } else if(value?.changed && value.changed.length > 0) {
+        val = JSON.stringify(value.changed);
+      }
+    }
+    return val;
+  }
+
+  function savePreferences(data) {
+    let _data = [];
+    for (const [key, value] of Object.entries(data.current)) {
+      let _metadata = prefSchema.current.schemaFields.filter((el) => { return el.id == key; });
+      if (_metadata.length > 0) {
+        let val = getCollectionValue(_metadata, value);
+        _data.push({
+          'category_id': _metadata[0]['cid'],
+          'id': parseInt(key),
+          'mid': _metadata[0]['mid'],
+          'name': _metadata[0]['name'],
+          'value': val,
+        });
+      }
+    }
+
+    if (_data.length > 0) {
+      save(_data, data);
+    }
+
+  }
+
+  function checkRefreshRequired(pref, requires_refresh) {
+    if (pref.name == 'theme') {
+      requires_refresh = true;
+    }
+
+    if (pref.name == 'user_language') {
+      requires_refresh = true;
+    }
+
+    return requires_refresh;
+  }
+
+  function save(save_data, data) {
+    api({
+      url: url_for('preferences.index'),
+      method: 'PUT',
+      data: save_data,
+    }).then(() => {
+      let requires_refresh = false;
+      /* Find the modules changed */
+      let modulesChanged = {};
+      for (const [key] of Object.entries(data.current)) {
+        let pref = pgAdmin.Browser.get_preference_for_id(Number(key));
+
+        if (pref['name'] == 'dynamic_tabs') {
+          _set_dynamic_tab(pgAdmin.Browser, !pref['value']);
+        }
+
+        if (!modulesChanged[pref.module]) {
+          modulesChanged[pref.module] = true;
+        }
+
+        requires_refresh = checkRefreshRequired(pref, requires_refresh);
+
+        if (pref.name == 'hide_shared_server') {
+          Notify.confirm(
+            gettext('Browser tree refresh required'),
+            gettext('A browser tree refresh is required. Do you wish to refresh the tree?'),
+            function () {
+              pgAdmin.Browser.tree.destroy({
+                success: function () {
+                  pgAdmin.Browser.initializeBrowserTree(pgAdmin.Browser);
+                  return true;
+                },
+              });
+            },
+            function () {
+              return true;
+            },
+            gettext('Refresh'),
+            gettext('Later')
+          );
+        }
+      }
+
+      if (requires_refresh) {
+        Notify.confirm(
+          gettext('Refresh required'),
+          gettext('A page refresh is required to apply the theme. Do you wish to refresh the page now?'),
+          function () {
+            /* If user clicks Yes */
+            location.reload();
+            return true;
+          },
+          function () { props.closeModal(); /*props.panel.close()*/ },
+          gettext('Refresh'),
+          gettext('Later')
+        );
+      }
+      // Refresh preferences cache
+      pgAdmin.Browser.cache_preferences(modulesChanged);
+      props.closeModal(); /*props.panel.close()*/
+    }).catch((err) => {
+      Notify.alert(err.response.data);
+    });
+  }
+
+  return (
+    <Box height={props.isFullScreen ? '100%' : '520px'}>
+      <Box className={classes.root}>
+        <Box className={clsx(classes.preferences)}>
+          <Box className={clsx(classes.treeContainer)}>
+            {prefTreeData &&
+            <PreferencesTree data={prefTreeData} getSelectedItem={(item) => {
+              if (item.type == 1) {
+                prefSchema.current.schemaFields.forEach((field) => {
+                  field.visible = field.parentId.toString() === item._metadata.data.id.toString();
+                });
+              }
+              setLoadTree(Math.floor(Math.random() * 1000));
+            }}
+            ></PreferencesTree>
+            }
+          </Box>
+          <Box className={clsx(classes.preferencesContainer)}>
+            {
+              prefSchema.current && loadTree > 0 ?
+                <RightPanel schema={prefSchema.current} initValues={initValues} onDataChange={(changedData) => {
+                  Object.keys(changedData).length > 0 ? setDisableSave(false) : setDisableSave(true);
+                  prefChangedData.current = changedData;
+                }}></RightPanel>
+                : <></>
+            }
+          </Box>
+        </Box>
+        <Box className={classes.footer}>
+          <Box className={classes.actionBtn} marginLeft="auto">
+            <DefaultButton className={classes.buttonMargin} onClick={() => { props.closeModal(); /*props.panel.close()*/ }} startIcon={<CloseSharpIcon onClick={() => { props.closeModal(); /*props.panel.close()*/ }} />}>
+              {gettext('Cancel')}
+            </DefaultButton>
+            <PrimaryButton className={classes.buttonMargin} startIcon={<SaveSharpIcon />} disabled={disableSave} onClick={() => { savePreferences(prefChangedData); }}>
+              {gettext('Save')}
+            </PrimaryButton>
+          </Box>
+        </Box>
+        {/* </Box> */}
+
+      </Box >
+    </Box>
+  );
+}
+
+PreferencesComponent.propTypes = {
+  schema: PropTypes.array,
+  initValues: PropTypes.object,
+  closeModal: PropTypes.func,
+  isFullScreen: PropTypes.bool,
+
+};
